#coding=UTF-8
#appModules/cdbxpp.py pour CdBurnerXp
# par Daniel Poiraud, AVH16. Version 1.1 du 27.09.2014.
import api
import controlTypes
import addonHandler
import appModuleHandler,winUser,scriptHandler,NVDAObjects,speech
from time import sleep
from scriptHandler import getLastScriptRepeatCount
from NVDAObjects.IAccessible import IAccessible, getNVDAObjectFromEvent
from winUser import getWindow,getForegroundWindow,getWindowText,getControlID,VK_BACK,keybd_event
from win32con import WM_KEYUP,WM_KEYDOWN
from ui import message
import ctypes
from ctypes import windll
import speech

user32 = windll.user32
GetWindow=winUser.getWindow
lastWindow=1
nextWindow=2
priorWindow=3
firstChild=5

class AppModule (appModuleHandler.AppModule):

	def fenetreZones(self, nom):
		hd0= user32.GetForegroundWindow()
		if nom=="lecteur" and not "Lecteur Audio" in winUser.getWindowText(hd0) :
			i = 0
			while i<20 and not "Lecteur Audio" in getWindowText(hd0) :
				hd0 = GetWindow(hd0,priorWindow)
				i = i+1
		if nom!="lecteur" and "Lecteur Audio" in getWindowText(hd0):
			i = 0
			while i<20 and not "Compilation" in getWindowText(hd0) :
				hd0 = GetWindow(hd0,nextWindow)
				i = i+1
		sleep(0.1)  #0.4
		hd1,hd2 = 0,0 
		if "Compilation Audio" in getWindowText(hd0):
			hd1 = GetWindow(GetWindow(hd0, firstChild), firstChild)  # audio
		if "Compilation de donn" in getWindowText(hd0):
			hd1 = GetWindow(GetWindow(GetWindow(hd0, firstChild), firstChild), firstChild)  #donnees
		if hd1 and nom == "ajouter" :
			hd2 = GetWindow(GetWindow(GetWindow(GetWindow(hd1, nextWindow), firstChild), nextWindow), firstChild)
		if hd1 and nom == "liste" :
			hd2 = GetWindow(GetWindow(GetWindow(GetWindow(hd1, firstChild), firstChild), nextWindow), firstChild) 
		if hd1 and nom == "arbo" :
			hd2 = GetWindow(GetWindow(GetWindow(hd1, firstChild), firstChild), firstChild) 
		if hd1 and nom == "compilation" and "Compilation Audio" in getWindowText(hd0):
			hd2 = GetWindow(GetWindow(hd1, nextWindow),firstChild)
		if hd1 and nom == "compilation" and "Compilation de donn" in getWindowText(hd0):	
			hd2 = GetWindow(GetWindow(GetWindow(GetWindow(GetWindow(hd1, nextWindow),firstChild), firstChild), nextWindow), firstChild)
		if nom=="lecteur" or nom=="retour":
			hd2 = hd0 
		return hd2

	def dansZone(self) :
		focus =api.getFocusObject()
		hd =focus.windowHandle
		nomFenetre = winUser.getWindowText(hd)
		return nomFenetre
		
	def event_gainFocus(self, obj, nextHandler):
		if obj.role == controlTypes.ROLE_LISTITEM :
			if  obj.IAccessibleChildID == 1 and not controlTypes.STATE_SELECTED in obj.states:
				obj.IAccessibleObject.accSelect (1|2,1)  
				return
		nextHandler()
		
	def script_ajouterFichiers (self,gesture):
		gesture.send()
		print (75)
		nomFenetre = self.dansZone() 
		if nomFenetre == "FileView1" :# File view
			hd = self.fenetreZones("ajouter")
			if getWindowText(hd) == "ToolStrip1":
				obj =getNVDAObjectFromEvent(hd,0,0)
				obj = obj.children[3].children[4]
				message(obj.name)
				obj.IAccessibleObject.accDoDefaultAction (0)
				#obj.setFocus()
			else :
				message(u"Bouton Ajouter non trouvé")
		else :
			message(u"Vous n'êtes pas dans la zone de liste.")

	def script_allerZoneArbo (self,gesture):
		gesture.send()
		print (76)
		if self.dansZone() == "FolderView1" :
			message(u"Vous êtes dans la zone d'arborescence")
			return
		hd = self.fenetreZones("arbo")
		if hd :
			winUser.setForegroundWindow(hd)
			sleep(0.1)
			winUser.setFocus(hd)
	
	def script_allerListe (self,gesture):
		gesture.send()
		print (77)
		if self.dansZone() == "FileView1" :
			message(u"Vous êtes dans la zone de liste")
			return
		hd = self.fenetreZones("liste")
		if hd :
			winUser.setForegroundWindow(hd)
			sleep(0.1)
			winUser.setFocus(hd)
			
	def script_allerCompilation (self,gesture):
		gesture.send()
		print (78)
		if self.dansZone() == "" and "SysListView32" in api.getFocusObject().windowClassName :
			message(u"Vous êtes dans la zone de compilation")
			return
		hd = self.fenetreZones("compilation")
		if hd :
			obj =getNVDAObjectFromEvent(hd,0,0)
			obj = obj.children[3]
			if obj.childCount==1:
				message("La compilation est vide")
			else :
				winUser.setForegroundWindow(hd)
				sleep(0.1)
				winUser.setFocus(hd)
				
	def script_allerLecteur (self,gesture):
		gesture.send()
		print (79)
		hd0= winUser.getForegroundWindow()
		if hd0 and not ("Compilation Audio" in getWindowText(hd0) or getWindowText(hd0)=="Lecteur Audio") :
			message(u"Vous n'êtes pas dans la compilation audio.")
			return
		if getWindowText(hd0) == "Lecteur Audio" :
			message(u"Le lecteur audio est activé.")
			return
		hd0 = self.fenetreZones("lecteur")
		if hd0 and getWindowText(hd0)=="Lecteur Audio" :
			hd = GetWindow(hd0,firstChild)
			obj =getNVDAObjectFromEvent(hd,0,0)
			obj = obj.children[3]
			winUser.setForegroundWindow(hd0)
			sleep(0.1)
			winUser.setFocus(hd)		
				
	def script_effacerCompilation (self,gesture):
		gesture.send()
		print (80)	
		message(u"Bouton Effacer la compilation actionné.")
		
	def script_retourFenetre(self,gesture):
		gesture.send()
		hd0= winUser.getForegroundWindow()
		if "Compilation" in getWindowText(hd0):  # Audio
			message(u"Vous êtes dans la fenêtre principale.")
			message(api.getFocusObject ().name)
			return
		hd0 = self.fenetreZones("retour")
		if hd0 and "Compilation" in getWindowText(hd0) :  # Audio
			winUser.setForegroundWindow(hd0)
			sleep(0.1)
			winUser.setFocus(hd0)	
			
	def script_supprimer(self,gesture):
		gesture.send()
		if "SysListView32" in api.getFocusObject().windowClassName:
			message(u"Suppression d'éléments.")
			
	def script_choixColonnesCompil (self,gesture):
		gesture.send()
		print (81)
		hd = self.fenetreZones("compilation")
		if hd :
			obj =getNVDAObjectFromEvent(hd,0,0)
			obj = obj.children[3]
			if obj.childCount !=1:
				message(u"La compilation doit être vide")
			else :
				obj = obj.firstChild.children[3].firstChild		
				(x, y, l, h) = obj.location
				x=x+l/2
				y=y+h/2
				winUser.setCursorPos (x,y)
				winUser.mouse_event(winUser.MOUSEEVENTF_RIGHTDOWN,0,0,None,None)
				winUser.mouse_event (winUser.MOUSEEVENTF_RIGHTUP,0,0,None,None)
		
	""" Partie lecteur audio  """

	def etatAffichageLecteur(self) :
		i, k = 0,100
		hd0 =winUser.getForegroundWindow()
		if hd0 and getWindowText(hd0)=="Lecteur Audio" :
			k = 2
		if hd0 and "Compilation Audio" in getWindowText(hd0):
			while i<200 and not "Lecteur Audio" in getWindowText(hd0) :
				hd0 = GetWindow(hd0,priorWindow)
				i = i+1
			if i<10 and not winUser.isWindowVisible(hd0): k = 0
			if i<10 and winUser.isWindowVisible(hd0): k = 1
		return k
		
	def script_infosLecteur(self,gesture) :  #alt+L
		gesture.send()	
		hd0 =winUser.getForegroundWindow()
		if hd0 and not ("Compilation Audio" in getWindowText(hd0) or getWindowText(hd0)=="Lecteur Audio") :
			message(u"Vous n'êtes pas dans la compilation audio.")
			return	
		k = self.etatAffichageLecteur()
		if k==1 : message(u"Le lecteur audio est affiché mais pas le focus.")
		if k==0 : message(u"Le lecteur audio est masqué. Alt+H, A, pour l'afficher")
		if k==2 : message(u"Le lecteur audio est affiché et en premier plan.")
		if k==100 : message(u"Lecteur audio non trouvé. Utilisez le menu Affichage.")

	def script_commandeLectureAudio (self,gesture) :  #control+L
		print (80)
		hd0 =winUser.getForegroundWindow()
		if hd0 and not ("Compilation Audio" in getWindowText(hd0) or getWindowText(hd0)=="Lecteur Audio") :
			message(u"Vous n'êtes pas dans la compilation audio.")
			return
		if hd0 and "Compilation Audio" in getWindowText(hd0): #(getWindowText(hd0)=="Lecteur Audio" or  
			i = 0
			while i<20 and not "Lecteur Audio" in getWindowText(hd0) :
				hd0 = GetWindow(hd0,priorWindow)
				i = i+1
			if i==20 : 
				message(u"Lecteur audio non trouvé.")  
				return
		if hd0 and getWindowText(hd0)=="Lecteur Audio" :
			obj =getNVDAObjectFromEvent(hd0,-4,0)
			obj = obj.children[0].children[3]
			obj.IAccessibleObject.accDoDefaultAction (0)
		
	def script_test (self,gesture):
		gesture.send()
		print (85)

	__gestures={
"kb:control+shift+J":"ajouterFichiers", 
"kb:delete":"supprimer",
"kb:control+0":"choixColonnesCompil",
"kb:control+,":"allerZoneArbo",
"kb:control+;":"allerListe", 
"kb:control+:":"allerCompilation",
"kb:control+shift+l":"allerLecteur",
"kb:control+!":"retourFenetre",
"kb:alt+L":"infosLecteur",
"kb:control+L":"commandeLectureAudio",
"kb:alt+c":"effacerCompilation",
"kb:control+shift+$":"test",
}